var gadgetres_id_status_protected		= 1;
var gadgetres_id_status_not_protected	= 2;
var gadgetres_id_status_not_up_to_date	= 3;
var gadgetres_id_background_color		= 10;

var gres_id_color_line	= 2;
var gres_id_logo		= 1000;

var init_retry_interval		= 5000;
var custom_refresh_interval = 5000;
var custom_refresh_interval_ratio = 1.5;

var status_protected		= 0;
var status_not_up_to_date	= 1;
var status_not_protected	= 2;
var status_unknown			= 3;

var oid_fs = "1.3.6.1.4.1.2213";
var oid_vp_status = oid_fs + ".12.2.140";
var oid_pf_status = oid_fs + ".25.2.10.20";

function on_load()
{

	initialize();
}

function initialize()
{
	if (policy.initialize(oid_fs + ".25.10"))
	{
		if (policy.register_oid(oid_vp_status) && policy.register_oid(oid_pf_status))
		{
			update_status();
			update_custom();
		}
	}
	else
		setTimeout("initialize()", init_retry_interval);
}

function on_doubleclick()
{
	open_main_gui();
}

function on_policy_change()
{
	update_status();
}

function update_custom()
{
	set_bgcolor();
	load_logo();
	custom_refresh_interval *= custom_refresh_interval_ratio;	
	setTimeout("update_custom()", custom_refresh_interval);
}

function set_bgcolor()
{
	var color;

	color = get_bgcolor();
	if (color != "")
		colorlayer.style.backgroundColor = "rgb(" + color + ")";
}

function load_logo()
{
	var res = new ActiveXObject("FSecure.ResourceHandler");
	var path;

	if (res.initialize("gres", "dll"))
	{
		try
		{
			path = res.get_icon_file_path(gres_id_logo);
		}
		catch (error)
		{
			return;
		}
		logo.src = path;
	}
}

function update_status()
{
	var res = new ActiveXObject("FSecure.ResourceHandler");
	var text = "";
	var text_id;
	var image = "statusyellow.png";
	var lang_id;
	var status;

	lang_id = get_lang_id();
	status = get_status();
	if (status != status_unknown)
	{
		switch (status)
		{
			case status_protected:
				image = "statusgreen.png";
				text_id = gadgetres_id_status_protected;
				break;
			case status_not_up_to_date:
				image = "statusyellow.png";
				text_id = gadgetres_id_status_not_up_to_date;
				break;
			case status_not_protected:
				image = "statusred.png";
				text_id = gadgetres_id_status_not_protected;
				break;
			default:
				return;
		}
		if (res.initialize("fsgadgetres", lang_id))
		{
			try
			{
				text = res.get_string(text_id);
			}
			catch (error)
			{
			}
		}
	}
	status_text.innerText = text;
	status_button.src = image;
}

function get_bgcolor()
{
	var gadgetres = new ActiveXObject("FSecure.ResourceHandler");
	var str = "";

	if (gadgetres.initialize("fsgadgetres", "dll"))
	{
		try
		{
			str = gadgetres.get_string(gadgetres_id_background_color);
		}
		catch (error)
		{
		}
	}
	if (str == "")
	{
		var gres = new ActiveXObject("FSecure.ResourceHandler");
		
		if (gres.initialize("gres", "dll"))
		{
			try
			{
				str = gres.get_string(gres_id_color_line);
			}
			catch (error)
			{
			}
		}
	}
	return str;
}

function get_lang_id()
{
	var id;

	try
	{
		id = read_reg_fs("Gadget\\LanguageId");
	}
	catch (error)
	{
		return "ENG";
	}
	return id;
}

function open_main_gui()
{
	var shell = new ActiveXObject("WScript.Shell");
	var dir;
	var exe_name;
	var command_line;

	try
	{
		dir = read_reg_fs("F-Secure GUI\\InstallationDirectory");
		exe_name = read_reg_fs("F-Secure GUI\\ExeName");
		command_line = read_reg_fs("F-Secure GUI\\CommandLine\\ShowMainWindow");
	}
	catch (error)
	{
		return;
	}
	shell.Run("\"" + dir + "\\" + exe_name + "\" " + command_line);
}

function read_reg_fs(value)
{
	var shell = new ActiveXObject("WScript.Shell");
	var platform;
	var reg_sw;

	platform = shell.RegRead("HKLM\\System\\CurrentControlSet\\Control\\" +
		"Session Manager\\Environment\\PROCESSOR_ARCHITECTURE");
	if (platform == "x86")
		reg_sw = "HKLM\\Software";
	else
		reg_sw = "HKLM\\Software\\Wow6432Node";
	return shell.RegRead(reg_sw + "\\Data Fellows\\F-Secure\\" + value);
}

function get_status()
{
	var vp_installed, vp_status, vp_enabled, vp_up_to_date;
	var pf_installed, pf_status, pf_enabled;

	vp_installed = is_vp_installed();
	pf_installed = is_pf_installed();
	if (! vp_installed && ! pf_installed)
		return status_not_protected;
	if (vp_installed)
	{
		try
		{
			vp_status = policy.get_int(oid_vp_status);
		}
		catch (error)
		{
			return status_unknown;
		}
		switch (vp_status)
		{
			case 32:
			case 33:
			case 34:
			case 35:
				vp_enabled = true;
				break;
			default:
				vp_enabled = false;
		}
		vp_up_to_date = (vp_status == 32);
		if (! vp_enabled)
			return status_not_protected;
	}
	if (pf_installed)
	{
		try
		{
			pf_status = policy.get_int(oid_pf_status);
		}
		catch (error)
		{
			return status_unknown;
		}
		pf_enabled = (pf_status == 1);
		if (! pf_enabled)
			return status_not_protected;
	}
	if (vp_installed && ! vp_up_to_date)
		return status_not_up_to_date;
	return status_protected;
}

function is_vp_installed()
{
	try
	{
		read_reg_fs("Anti-Virus\\CurrentVersion");
		return true;
	}
	catch (error)
	{
		return false;
	}
}

function is_pf_installed()
{
	try
	{
		read_reg_fs("Internet Shield\\CurrentVersion");
		return true;
	}
	catch (error)
	{
		return false;
	}
}
